/*
 * ppp_internal.h
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993  Bryce Nutter
 *
 *
 */

#define PPP_MAX_INTERFACES  8
#define HLEN                5
#define TRUE                1
#define FALSE               0
#define MAX_SERIAL_BLOCKS   64
#define PPP_MAX_INSTANCES   32
#define MAX_ERROR_COUNT     1024
#define DEVICEA             "/dev/ttya"
#define DEVICEB             "/dev/ttyb"
#define INUSE               1
#define NOREF               0
#define CLEAR_REF(_bp)      (_bp)->ref = NOREF
#define XOR                 0x20
#define CEO                 0x7d
#define TLEN                3
#define	ACTIVE_MAP_SIZE     23
#define	PASSIVE_MAP_SIZE    23
#define LLEN                (sizeof(LCPHDR))
#define COLEN               (sizeof(CONF_OPT))
#define TTYB                2
#define TTYA                1
#define MAX_T_INFO          200
#define STD_DELAY           3
#define MRU_FORMAT_LEN      0x04
#define DEFAULT_MRU         1500    

typedef struct activeid {
  int device_name;
} ActiveId;

typedef struct passiveid {
  int device_name;
} PassiveId;

typedef struct i_face_type {
  int  MYPPPAddr_int;
  int  THEIRPPPAddr_int;
  int  mtu;
  int  device;
} i_face;

typedef struct pppstate {
  Map    activemap;
  Map    passivemap;
  int    n_interfaces;
  int    llpProt;
  i_face interface[PPP_MAX_INTERFACES]; 
} PPPSTATE;

typedef struct sstate {
  u_short   Protocol;
  int       State;
  u_char    *bptr;
  int       iplen;
  int       msglen;
  u_char    *realbufPtr;
  u_char    *orealbufPtr;
} SSTATE;

typedef struct sinfo {
  XObj s;
  Msg  *m;
} storeInfo;

typedef struct {
    char id;
    char ref;
    int cur_len;
    u_char *data;
    u_char *data_buf;
    Msg *msg; 
    Semaphore sem;
    XObj self;
} block;

block *old_bp;

typedef struct {
    int total_blocks;
    int next_block;
    block blocks[MAX_SERIAL_BLOCKS];
} block_pool;

typedef struct {
    char ref;
    u_char *data;
} blck;
blck *oldbp;

typedef struct {
    int total_blocks;
    int next_block;
    blck blocks[MAX_SERIAL_BLOCKS];
} block_p;

typedef struct To_info {
  XObj      s;
  u_char    Code;
  int       alloc;
} TO_INFO;
TO_INFO   T_out_data[MAX_T_INFO];

typedef struct Lcp_Hdr {
  u_char Code;
  u_char Identifier;
  u_short Length;
} LCPHDR;

typedef struct Conf_Opt {
  u_char Type;
  u_char Length;
  u_short Mru;
} CONF_OPT;

static block_p    pol;

int  wus = 0;
int  big_len = 0;
int  again = 0;
int  okayed = 0;
int  already_opened = 0;
int  First_Flag = 0,prev_write=0;
int  tracepppp;

extern int  CHUNK;
int  DEVICE_MTU=0;
int  length,sent_first = 0;
int  received_first = 0,receive_mode = 0; 
int  rval,prev_mask;

extern  int errno;
char    inspeed = 0;
XObj    ppp_obj;
Event   handle;
u_char  Flag_h,Flag_t,Address,Control;
u_short Protocolh,Fcs;

int  instance=0;

block_pool pool;

struct hostent *hp; 

Semaphore ppp_enable;
Semaphore demux_sem;
Semaphore ppp_disable;
Semaphore link_sync;
Semaphore handle_sync;
Semaphore device_lock;
