/*
 * x-kernel v3.2
 *
 * Copyright (c) 1993  Arizona Board of Regents
 */

#ifndef ripgrd_i_h
#define ripgrd_i_h

#define	RIPGRD_ACT_MAP_SZ	11
#define	RIPGRD_PAS_MAP_SZ	11

typedef struct {
    Map		activeMap;
    Map 	passiveMap;
    int		grpid;
} PState;


#define IDTYPE  long
#define GRPMEM_MAX_PARTS  16
#define KM_PROTL 1

/* Internal information of the RIP protocol */

#define RIP_REQUEST     1       /* message requests routes              */
#define RIP_RESPONSE    2       /* message contains route advertisement */

#define RIPNULLADDR 8
 
struct  riprt {
        short   rr_family;      /* 4BSD Address Family                  */
        short   rr_mbz;         /* must be zero                         */
        IPhost  rr_addr;        /* ip address                           */
        char    rr_mbz2[RIPNULLADDR];   /* must be zero
*/
        int     rr_metric;      /* distance (hop count) metric          */
};


#define MAXRIPROUTES 25

/* RIP packet structure */
struct  rip {
        char    rip_cmd;        /* RIP command                          */
        char    rip_vers;       /* RIP_VERSION, above                   */
        short   rip_mbz;        /* must be zero                         */
        struct  riprt   rip_rts[MAXRIPROUTES];
};

#define RIPHSIZE 4

#endif
