/**********************************************************/
/* Mach3: This is an altered version of udp_hdr.h         */
/*        to be used when building an in-kernel version   */
/*        of the x-kernel. That is due to the fact that   */
/*        up to now usc/usit produce strict ANSI C code   */
/*        while in-kernel code is compiled with a K&R cc. */
/*        It works for mach3-mips and mach3-intelx86.     */
/*                                                        */
/* This should be fixed in the next usc/usit release.     */
/*                                                        */
/* Based on the files listed below as USC/USIT input      */
/**********************************************************/

/**********************************************************/
/*                                                        */
/*                  USC Types                             */
/*                  Wed Nov 16 16:03:24 1994              */
/*                  File: udp_hdr.usc                     */
/*                                                        */
/**********************************************************/
/* 
 * $RCSfile: udp_hdr.h,v $
 *
 * x-kernel v3.2
 *
 * Copyright (c) 1993,1991,1990  Arizona Board of Regents
 *
 * usc/usit v1.0
 *
 * Copyright (c) 1994  Arizona Board of Regents
 *
 * $Revision: 1.1 $
 * $Date: 1994/11/23 16:52:34 $
 */

#if defined(__STDC__) || defined(__GNUC__)
void  udpHdrCopyIn(void* l_native_header, void* l_net_header);
void  udpHdrCopyOut(void* l_net_header, void* l_native_header);
void  udpHdrCopyUOut(void* l_net_header, void* l_native_header);
void  udpHdrCopyUIn(void* l_native_header, void* l_net_header);
#else
void  udpHdrCopyIn();
void  udpHdrCopyOut();
void  udpHdrCopyUOut();
void  udpHdrCopyUIn();
#endif

#define pokeNetUdpCksum(l_net_header,l_sum)  \
  do {\
  unsigned long r0;\
  r0 = *(unsigned char *)((unsigned char *)l_sum + (0));\
  *((char *)((char *)l_net_header + (6))) =\
      (r0);\
  r0 = *(unsigned char *)((unsigned char *)l_sum + (1));\
  *((char *)((char *)l_net_header + (7))) =\
      (r0);\
}\
 while (0)

#define peekNetUdpLen(l_net_header,l_len)  \
  do {\
  unsigned long r0;\
  r0 = *(unsigned char *)((unsigned char *)l_net_header + (4));\
  *((char *)((char *)l_len + (0))) =\
      (r0);\
  r0 = *(unsigned char *)((unsigned char *)l_net_header + (5));\
  *((char *)((char *)l_len + (1))) =\
      (r0);\
}\
 while (0)

