/*
 * cookie_i.h
 *
 * x-kernel v3.2
 *
 *
 *
 */

#define HOSTTYPE IPhost

typedef struct {
    Map		cookieMap;
    Map		cookiePassMap;
    int		bowl[4];
    int		p1;
    int		p2;
    int		p3;
} PState;

#define COOKIE_MAP_SIZE 32

/* hash size in bytes */
#define HASH_SIZE_BYTES 16

typedef unsigned char cookie_t[HASH_SIZE_BYTES];

typedef struct {
  cookie_t	*this_cookie, *that_cookie;
  Semaphore	cookie_wait;
  HOSTTYPE	remhost;
  Msg		msg;
  int		waiting;
} SState;

typedef struct {
  unsigned char		type;
  cookie_t	this_cookie;
  cookie_t	that_cookie;
} cookie_msg_t;

/* one byte type in header */
#define COOKIE_NET_TYPE_SIZE 1

#define COOKIE_REQUEST  255
#define COOKIE_RESPONSE 254
#define COOKIE_NORMAL   253

#define COOKIE_WAIT 1000000



